pipeline {
    agent any
    environment {
      DOCKER_REPO = 'registry.gitlab.com/dime.nicius/semantix_devops'
      CONTAINER_NAME = 'semantix_devops'
    }
    stages {

        stage('Checkout Semantix Repo') {
        steps {
            git branch: 'master',
                url: 'https://gitlab.com/dime.nicius/semantix_devops.git'

            sh "ls -lat"
        }
    }
      
        stage('Build docker image') {
          
          steps {
            script {
              withDockerRegistry([credentialsId: 'gitlab_registry', url: "https://${DOCKER_REPO}"]) {
                def customImage = docker.build("${DOCKER_REPO}:${env.BUILD_ID}", '.')
                customImage.push()
                customImage.push('latest')
              }
            }
          }
        }

        stage('Run container') {
          
          steps {
              sh "docker stop ${CONTAINER_NAME} || echo O container: ${CONTAINER_NAME} nao esta rodando"
              sh "docker rm ${CONTAINER_NAME} || echo O container: ${CONTAINER_NAME} nao existe"
              sh "docker run --name ${CONTAINER_NAME} -d -p 4000:4000 ${DOCKER_REPO}:latest"
            }
          }
        }
    }
